//+------------------------------------------------------------------+
//|                                                      EA SMA2.mq5 |
//|                                                      Aleksej1966 |
//|                        https://www.mql5.com/ru/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "Aleksej1966"
#property link      "https://www.mql5.com/ru/users/aleksej1966"
#property version   "1.00"
#include <Trade\Trade.mqh>
CTrade trade;

input ushort PeriodM=10,
             PeriodN=170,
             LvlOpen=7,
             LvlClose=40;

input bool Filter=false;

char buy,sell;
int periodM,periodN,m_coeff[];
double lot;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   trade.SetDeviationInPoints(10);
   trade.SetAsyncMode(true);
   trade.SetTypeFillingBySymbol(_Symbol);

   lot=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);

   periodM=MathMax(1,PeriodM);
   periodN=periodM+MathMax(1,PeriodN);

   ArrayResize(m_coeff,periodN);
   ArrayInitialize(m_coeff,-periodM);

   for(int i=0; i<periodM; i++)
      m_coeff[i]=m_coeff[i]+periodN;

   int bars=MathMin(iBars(_Symbol,PERIOD_CURRENT),TerminalInfoInteger(TERMINAL_MAXBARS));

   for(int i=bars-periodN-1; i>=0; i--)
      CalcSignal(i);

   NewBar();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
//---
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   if(NewBar()==true)
     {
      CalcSignal(0);

      if(buy>0)
         trade.PositionOpen(_Symbol,ORDER_TYPE_BUY,lot,SymbolInfoDouble(_Symbol,SYMBOL_ASK),0,0,NULL);

      if(sell>0)
         trade.PositionOpen(_Symbol,ORDER_TYPE_SELL,lot,SymbolInfoDouble(_Symbol,SYMBOL_BID),0,0,NULL);

      if(buy<0 || sell<0)
        {
         ENUM_POSITION_TYPE type=buy<0?POSITION_TYPE_BUY:POSITION_TYPE_SELL;
         for(int i=PositionsTotal()-1; i>=0; i--)
           {
            ulong ticket=PositionGetTicket(i);
            if(PositionSelectByTicket(ticket)==true && type==(ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE))
               trade.PositionClose(ticket,10);
           }
        }
     }
//---
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CalcSignal(int bar)
  {
//---
   static int array[][2],size,cnt;

   if(size==0)
      ArrayResize(array,size,100);

   double sum=0;

   for(int j=0; j<periodN; j++)
      sum=sum+m_coeff[j]*iOpen(_Symbol,PERIOD_CURRENT,bar+j);

   int diff=(int)MathRound(sum/_Point),ind=ArrayBsearch(array,diff);

   if(ind>=0 && array[ind][0]==diff)
      array[ind][1]++;
   else
     {
      ArrayResize(array,size+1);
      array[size][0]=diff;
      array[size][1]=1;
      size++;
      ArraySort(array);
     }

   cnt++;

   if(bar==0)
     {
      int res=0,openbuy=0,closebuy=0,opensell=0,closesell=0;
      for(int i=0; i<size; i++)
        {
         res=res+array[i][1];
         if(100*res<=cnt*LvlOpen)
            openbuy=array[i][0];

         if(100*res<=cnt*LvlClose)
            closebuy=array[i][0];
         else
            break;
        }

      res=0;
      for(int i=size-1; i>=0; i--)
        {
         res=res+array[i][1];
         if(100*res<=cnt*LvlOpen)
            opensell=array[i][0];

         if(100*res<=cnt*LvlClose)
            closesell=array[i][0];
         else
            break;
        }

      buy=0;
      sell=0;

      if(diff<openbuy)
         buy=1;

      if(diff>opensell)
         sell=1;

      if(diff>=closebuy)
         buy=-1;

      if(diff<=closesell)
         sell=-1;

      if(Filter==true)
        {
         double open=iOpen(_Symbol,PERIOD_CURRENT,0),
                openM=iOpen(_Symbol,PERIOD_CURRENT,periodM);

         if(buy>0 && open<=openM)
            buy=0;

         if(sell>0 && open>=openM)
            sell=0;
        }
     }
//---
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool NewBar()
  {
//---
   static long lastbar;
   long curbar=SeriesInfoInteger(_Symbol,PERIOD_CURRENT,SERIES_LASTBAR_DATE);
   if(lastbar<curbar)
     {
      lastbar=curbar;
      return(true);
     }
   return(false);
//---
  }
//+------------------------------------------------------------------+
